<!-- $Id: relnotes.sgml,v 1.9 1996/01/31 14:26:15 mpp Exp $ -->
<!-- The FreeBSD Documentation Project -->

<!--
<!DOCTYPE linuxdoc PUBLIC '-//FreeBSD//DTD linuxdoc//EN'>
<linuxdoc><book><chapt>foo
-->
      <sect><heading>About the current release<label id="relnotes"></heading>

	<p>FreeBSD is a freely available, full source 4.4 BSD
	  Lite based release for Intel i386/i486/Pentium (or
	  compatible) based PC's.  It is based primarily on
	  software from U.C. Berkeley's CSRG group, with some
	  enhancements from NetBSD, 386BSD, and the Free Software
	  Foundation.

	  Since our release of FreeBSD 2.0 one year ago, the
	  performance, feature set, and stability of FreeBSD has
	  improved dramatically.  The largest change is a
	  revamped VM system with a merged VM/file buffer cache
	  that not only increases performance, but reduces
	  FreeBSD's memory footprint, making a 5MB configuration
	  a more acceptable minimum.  Other enhancements include
	  full NIS client and server support, transaction TCP
	  support, dial-on-demand PPP, an improved SCSI
	  subsystem, early ISDN support, support for FDDI and
	  Fast Ethernet (100Mbit) adapters, improved support for
	  the Adaptec 2940 (WIDE and narrow) and many hundreds of
	  bug fixes.

	  We've also taken the comments and suggestions of many
	  of our users to heart and have attempted to provide
	  what we hope is a more sane and easily understood
	  installation process.  Your feedback on this
	  (constantly evolving) process is especially welcome!

	  In addition to the base distributions, FreeBSD offers a
	  new ported software collection with some 350 commonly
	  sought-after programs.  The list of ports ranges from
	  http (WWW) servers, to games, languages, editors and
	  almost everything in between.  The entire ports
	  collection requires only 10MB of storage, all ports
	  being expressed as ``deltas'' to their original sources.
	  This makes it much easier for us to update ports, and
	  greatly reduces the disk space demands made by the
	  older 1.0 ports collection.  To compile a port, you
	  simply change to the directory of the program you wish
	  to install, type make and let the system do the rest.
	  The full original distribution for each port you build
	  is retrieved dynamically off of CDROM or a local ftp
	  site, so you need only enough disk space to build the
	  ports you want.  (Almost) every port is also provided
	  as a pre-compiled "package" which can be installed with
	  a simple command (pkg_add) by those who do not wish to
	  compile their own ports from source.

	  A number of additional documents which you may find
	  very helpful in the process of installing and using
	  FreeBSD may now also be found in the
	  <bf>/usr/share/doc</bf> directory.  You may view the
	  manuals with any HTML capable browser with the
	  following URLs:

	  <descrip>
	    <tag>The FreeBSD handbook</tag>
	      <htmlurl url="file:/usr/share/doc/handbook/handbook.html">

	    <tag>The FreeBSD FAQ</tag>
	      <htmlurl url="file:/usr/share/doc/FAQ/freebsd-faq.html">
	  </descrip>

	  You can also visit the master (and most frequently
	    updated) copies at <htmlurl
	    url="http://www.freebsd.org"
	    name="http://www.freebsd.org">.

	  The core of FreeBSD does not contain DES code which
	  would inhibit its being exported outside the United
	  States.  There is an add-on package to the core
	  distribution, for use only in the United States, that
	  contains the programs that normally use DES.  The
	  auxiliary packages provided separately can be used by
	  anyone.  A freely (from outside the U.S.) exportable
	  European distribution of DES for our non-U.S. users
	  also exists and is described in the <htmlurl
	  url="../FAQ/freebsd-faq.html" name="FreeBSD FAQ">.

	  If password security for FreeBSD is all you need, and
	  you have no requirement for copying encrypted passwords
	  from different hosts (Suns, DEC machines, etc) into
	  FreeBSD password entries, then FreeBSD's MD5 based
	  security may be all you require!  We feel that our
	  default security model is more than a match for DES,
	  and without any messy export issues to deal with.  If
	  you're outside (or even inside) the U.S., give it a
	  try!

<![ IGNORE [
	<p>Since our first release of FreeBSD 1.0 nearly two
	  years ago, FreeBSD has changed dramatically.  Since
	  release 2.0, FreeBSD has been based on the Berkeley BSD
	  4.4-lite code rather than the Net2 code used for
	  previous versions.  In addition to clearing the legal
	  issues that surrounded the Net2 code, the port to 4.4
	  has also brought in numerous new features, filesystems
	  and enhanced driver support.

          Since our release of FreeBSD 2.0 in November of 1994,
	  the performance, feature set, and stability of FreeBSD
	  has improved dramatically.  The largest change is a
	  revamped Virtual Memory (VM) system with a merged
	  virtual memory and file buffer cache.  This increases
	  performance while reducing FreeBSD's memory footprint,
	  making a system with 4 megabytes of RAM a more
	  acceptable minimum.  Other enhancements include full
	  NIS client and server support, transaction TCP support,
	  dial on demand PPP, an improved SCSI subsystem, early
	  support for ISDN, support for FDDI and 100Mbit Fast
	  Ethernet adapters, improved support for the Adaptec
	  2940 and hundreds of bug fixes.

	  We've also taken the comments and suggestions of many
	  of our users to heart and have attempted to provide
	  what we hope is a more sane and easily understood
	  installation process.  Your feedback on this constantly
	  evolving process is especially welcome!

	  In addition to the base distributions, FreeBSD offers a
	  new ported software collection with some 270 commonly
	  sought-after programs.  The list of ports ranges from
	  World Wide Web (http) servers, to games, languages,
	  editors and almost everything in between.  The entire
	  ports collection requires only 10MB of storage because
	  each port contains only the changes required for the
	  source code to compile on FreeBSD and the information
	  necessary to automatically retrieve the original
	  sources.  The original distribution for each port you
	  build is automatically retrieved off of CD-ROM or a via
	  anonymous ftp, so you need only enough disk space to
	  build the ports you want.  Each port is also provided
	  as a pre-compiled package which can be installed with
	  the <tt>pkg_add(1)</tt> command for those who do not
	  wish to compile their own ports from source.  See <ref
	  id="ports" name="The Ports Collection"> for a more
	  complete description.

<!-- XXX make xref 
	  For a list of contributors and a general project
	  description, please see the file "CONTRIB.FreeBSD"
	  which should be bundled with your binary distribution.

	  Also see the "REGISTER.FreeBSD" file for information on
	  registering with the "Free BSD user counter".  This
	  counter is for ALL freely available variants of BSD,
	  not just FreeBSD, and we urge you to register yourself
	  with it.
-->

	  The core of FreeBSD does not contain DES code which
	  would inhibit its being exported outside the United
	  States.  An add-on package, for use only in the United
	  States, contains the programs that normally use DES.
	  The auxiliary packages provided separately can be used
	  by anyone.  A freely exportable European distribution
	  of DES for our non-U.S. users also exists and is
	  described in the <url
	  url="http://www.freebsd.org/FAQ" name="FreeBSD
	  FAQ">.  If password security for FreeBSD is all you
	  need, and you have no requirement for copying encrypted
	  passwords from other hosts using DES into FreeBSD
	  password entries, then FreeBSD's MD5 based security may
	  be all you require.  We feel that our default security
	  model is more than a match for DES, and without any
	  messy export issues to deal with.

	  FreeBSD 2.0.5 represents the culmination of 2 years of
	  work and many thousands of man hours put in by an
	  international development team.  We hope you enjoy it!

	<sect1><heading>New feature highlights</heading>

	  <p>The following features were added or substantially
	    improved between the release of 2.0 and this 2.0.5
	    release.  In order to facilitate better
	    communication, the person, or persons, responsible
	    for each enhancement is noted.  Any questions
	    regarding the new functionality should be directed to
	    them first.

	  <sect2><heading>Kernel</heading>

	    <p>
	      <descrip>

		<tag>Merged VM-File Buffer Cache</tag> A merged
		  VM/buffer cache design greatly enhances overall
		  system performance and makes it possible to do
		  a number of more optimal memory allocation
		  strategies that were not possible before.

		  Owner: David Greenman (davidg@FreeBSD.org) and
                        John Dyson (dyson@implode.root.com)

		<tag>Network PCB hash optimization</tag> For
		  systems with a great number of active TCP
		  connections (WEB and ftp servers, for example),
		  this greatly speeds up the lookup time required
		  to match an incoming packet up to its
		  associated connection.

		  Owner: David Greenman (davidg@FreeBSD.org)

		<tag>Name cache optimization</tag> The name-cache
		  would cache all files of the same name to the
		  same bucket, which would put for instance all
		  ".." entries in the same bucket.  We added the
		  parent directory version to frustrate the hash,
		  and improved the management of the cache in
		  various other ways while we were at it.

	          Owner: Poul-Henning Kamp (phk@FreeBSD.org)
                  David Greenman (davidg@FreeBSD.org)

		<tag>Less restrictive swap-spaces</tag> The need
		  to compile the names of the swap devices into
		  the kernel has been removed.  Now
		  <tt>swapon(8)</tt> will accept any block
		  devices, up to the maximum number of swap
		  devices configured in the kernel.

		  Owner: Poul-Henning Kamp (phk@FreeBSD.org)
			David Greenman (davidg@FreeBSD.org)

		<tag>Hard Wired SCSI Devices</tag> Prior to
		  2.0.5, FreeBSD performed dynamic assignment of
		  unit numbers to SCSI devices as they were
		  probed, allowing a SCSI device failure to
		  possibly change unit number assignment.  This
		  could cause filesystems other disks in the
		  system to be incorrectly mounted, or not
		  mounted at all.  Hard wiring allows static
		  allocation of unit numbers (and hence device
		  names) to scsi devices based on SCSI ID and
		  bus.  SCSI configuration occurs in the kernel
		  config file.  Samples of the configuration
		  syntax can be found in the <tt>scsi(4)</tt> man
		  page or the LINT kernel config file.

		  Owner: Peter Dufault (dufault@hda.com) 

                  Sources involved: <tt>sys/scsi/*</tt>
	          <tt>usr.sbin/config/*</tt>

		<tag>Slice Support</tag> FreeBSD now supports a
		  <em>slice</em> abstraction which enhances
		  FreeBSD's ability to share disks with other
		  operating systems.  This support will allow
		  FreeBSD to inhabit DOS extended partitions.

		  Owner: Bruce Evans (bde@FreeBSD.org)

		  Sources involved: <tt>sys/disklabel.h</tt>
		  <tt>sys/diskslice.h</tt> <tt>sys/dkbad.h</tt>
		  <tt>kern/subr_diskslice.c</tt> <tt>kern/subr_dkbad.c</tt>
		  <tt>i386/isa/diskslice_machdep.c</tt> <tt>i386/isa/wd.c</tt>
		  <tt>scsi/sd.c</tt> <tt>dev/vn/vn.c</tt>

		<tag>Support for Ontrack Disk Manager Version 6.0</tag>
                  Support has been added for disks
		  which use Ontrack Disk Manager.  The fdisk
		  program does <em>not</em> know about it
		  however, so make all changes using the install
		  program on the boot.flp or the Ontrack Disk
		  Manager tool under MS-DOS.

		  Owner: Poul-Henning Kamp (phk@FreeBSD.org)

		<tag>Bad144 is back and working</tag> Bad144
		  works again, though the semantics are slightly
		  different than before in that the bad-spots are
		  kept relative to the slice rather than absolute
		  on the disk.

		  Owner: Bruce Evans (bde@FreeBSD.org)
		  Poul-Henning Kamp (phk@FreeBSD.org)

	      </descrip>

      <sect2><heading>New device support</heading>

	<sect3><heading>SCSI and CDROM devices</heading>

	  <p><descrip>

	      <tag>Matsushita/Panasonic (Creative) CD-ROM driver</tag> 
                The Matsushita/Panasonic CR-562 and
		CR-563 drives are now supported when connected to
		a Sound Blaster or 100% compatible host adapter.
		Up to four host adapters are supported for a
		total of 16 CD-ROM drives.  The audio functions
		are supported with the Karoke variable speed
		playback.

		Owner: Frank Durda IV
		(bsdmail@nemesis.lonestar.org)

		Sources involved: <tt>isa/matcd</tt>

	      <tag>Adaptec 2742/2842/2940 SCSI driver</tag> The
		original 274x/284x driver has evolved
		considerably since the 2.0 release of FreeBSD.
		We now offer full support for the 2940 series as
		well as the Wide models of these cards.  The
		arbitration bug that caused problems with fast
		devices has been corrected and
		<em>experimental</em> tagged queuing support has
		been added (kernel option
		<tt>AHC_TAGENABLE</tt>).  John Aycock has also
		released the sequencer code under a Berkeley
		style copyright making the driver entirely clean
		of the GPL.

		Owner: Justin Gibbs (gibbs@FreeBSD.org)

		Sources involved: <tt>isa/aic7770.c</tt> <tt>pci/aic7870.c</tt>
		<tt>i386/scsi/*</tt> <tt>sys/dev/aic7xxx/*</tt>

	      <tag>NCR5380/NCR53400 SCSI (ProAudio Spectrum) driver</tag>
                Owner: core

		Submitted by: Serge Vakulenko (vak@cronyx.ru)

		Sources involved: <tt>isa/ncr5380.c</tt>

	      <tag>Sony CDROM driver</tag> Owner: core

		Submitted by: Mikael Hybsch (micke@dynas.se)

		Sources involved: <tt>isa/scd.c</tt>

	    </descrip>

	<sect3><heading>Serial devices</heading>

	  <p><descrip>

	      <tag>SDL Communications Riscom/8 Serial Board Driver</tag> 
	        Owner: Andrey Chernov
		(ache@FreeBSD.org)

		Sources involved: <tt>isa/rc.c</tt> <tt>isa/rcreg.h</tt>

	      <tag>Cyclades Cyclom-y Serial Board Driver</tag>
		Owner: Bruce Evans (bde@FreeBSD.org)

		Submitted by: Andrew Werple
		(andrew@werple.apana.org.au) and Heikki Suonsivu
		(hsu@cs.hut.fi)

		Obtained from: NetBSD

		Sources involved: <tt>isa/cy.c</tt>

	      <tag>Cronyx/Sigma sync/async serial driver</tag>
		Owner: core

		Submitted by: Serge Vakulenko

		Sources involved: <tt>isa/cronyx.c</tt>

	    </descrip>

      <sect2><heading>Networking</heading>

	<p><descrip>

	    <tag>Diskless booting</tag> Diskless booting in 2.0.5
	      is much improved over previous releases.  The boot
	      program is in <tt>src/sys/i386/boot/netboot</tt>,
	      and can be run from an MS-DOS system or burned into
	      an EPROM.  WD, SMC, 3COM and Novell ethernet cards
	      are currently supported. Local swapping is also
	      supported.

	    <tag>DEC DC21140 Fast Ethernet driver</tag> This
	      driver supports any of the numerous NICs using the
	      DC21140 chipset including the 100Mb DEC DE-500-XA
	      and SMC 9332.

	      Owner: core

	      Submitted by: Matt Thomas (thomas@lkg.dec.com)

	      Sources involved: <tt>pci/if_de.c</tt> <tt>pci/dc21040.h</tt>


	    <tag>DEC FDDI (DEFPA/DEFEA) driver</tag> Owner: core

	      Submitted by: Matt Thomas (thomas@lkg.dec.com)

	      Sources involved: <tt>pci/if_pdq.c</tt> <tt>pci/pdq.c</tt>
	      <tt>pci/pdq_os.h</tt> <tt>pci/pdqreg.h</tt>


	    <tag>3Com 3c505 (Etherlink/+) NIC driver</tag> Owner:
	      core

	      Submitted by: Dean Huxley (dean@fsa.ca)

	      Obtained from: NetBSD

	      Sources involved: <tt>isa/if_eg.c</tt>


	    <tag>Fujitsu MB86960A family of NICs driver</tag>
	      Owner: core

	      Submitted by: M.S. (seki@sysrap.cs.fujitsu.co.jp)

	      Sources involved: <tt>isa/if_fe.c</tt>


	    <tag>Intel EtherExpress driver</tag> Owner: Rodney
	      W. Grimes (rgrimes@FreeBSD.org)

	      Sources involved: <tt>isa/if_ix.c</tt> <tt>isa/if_ixreg.h</tt>


	    <tag>3Com 3c589 driver</tag> Owner: core

	      Submitted by: "HOSOKAWA Tatsumi"
	      (hosokawa@mt.cs.keio.ac.jp), Seiji Murata
	      (seiji@mt.cs.keio.ac.jp) and Noriyuki Takahashi
	      (hor@aecl.ntt.jp)

	      Sources involved: <tt>isa/if_zp.c</tt>


	    <tag>IBM Credit Card Adapter driver</tag> Owner: core

	      Submitted by: "HOSOKAWA Tatsumi"
	      (hosokawa@mt.cs.keio.ac.jp), 

	      Sources involved: <tt>isa/pcic.c</tt> <tt>isa/pcic.h</tt>


	    <tag>EDSS1 and 1TR6 ISDN interface driver</tag>
	      Owner: core

	      Submitted by: Dietmar Friede
	      (dfriede@drnhh.neuhaus.de) and Juergen Krause
	      (jkr@saarlink.de)

	      Sources involved: <tt>gnu/isdn/*</tt>

	  </descrip>

      <sect2><heading>Miscellaneous drivers</heading>

	<p><descrip>

	    <tag>Joystick driver</tag> Owner: Jean-Marc Zucconi
	      (jmz@FreeBSD.org)

	      Sources involved: <tt>isa/joy.c</tt>
	      
	    <tag>National Instruments ``LabPC'' driver</tag> Owner:
	      Peter Dufault (dufault@hda.com)

	      Sources involved: <tt>isa/labpc.c</tt>
	      
	    <tag>WD7000 driver</tag> Owner: Olof Johansson
	      (offe@ludd.luth.se)
	      
	    <tag>Pcvt Console driver</tag> Owner: J&ouml;rg Wunsch
	      (joerg@FreeBSD.org)

	      Submitted by: Hellmuth Michaelis
	      (hm@altona.hamburg.com)

	      Sources involved: <tt>isa/pcvt/*</tt>

	    <tag>BSD-audio emulator for VAT driver</tag> Owner:
	      Amancio Hasty (ahasty@FreeBSD.org) and
	      Paul Traina (pst@FreeBSD.org)

	      Sources involved: <tt>isa/sound/vat_audio.c</tt>
	      <tt>isa/sound/vat_audioio.h</tt>

	    <tag>National Instruments AT-GPIB and AT-GPIB/TNT GPIB driver</tag>
              Owner: core

	      Submitted by: Fred Cawthorne
	      (fcawth@delphi.umd.edu)

	      Sources involved: <tt>isa/gpib.c</tt> <tt>isa/gpib.h</tt>
	      <tt>isa/gpibreg.h</tt>

	    <tag>Genius GS-4500 hand scanner driver</tag> Owner:
	      core

	      Submitted by: Gunther Schadow
	      (gusw@fub46.zedat.fu-berlin.de)

	      Sources involved: <tt>isa/gsc.c</tt> <tt>isa/gscreg.h</tt>

	    <tag>CORTEX-I Frame Grabber</tag> Owner: core

	      Submitted by: Paul S. LaFollette, Jr. (

	      Sources involved: <tt>isa/ctx.c</tt> <tt>isa/ctxreg.h</tt>


	    <tag>Video Spigot video capture card</tag> Owner: Jim
	      Lowe
	      
	  </descrip>

    <sect1><heading>Experimental features</heading>

      <p><descrip> 

	  <tag>UNIONFS and LFS</tag> The unionfs and LFS file
	    systems are known to be severely broken in FreeBSD
	    2.0.5.  This is in part due to old bugs that we
	    haven't had time to resolve yet and the need to
	    update these file systems to deal with the new VM
	    system.  We hope to address these issues in a later
	    release of FreeBSD.

	  <tag>iBCS2 Support</tag> FreeBSD now supports running
	    iBCS2 compatible binaries.  Currently SCO UNIX 3.2.2
	    and 3.2.4, and ISC 2.2 COFF are supported.  The iBCS2
	    emulator is in its early stages and has not been
	    extensively tested, but it is functional.  Most of
	    SCO's 3.2.2 binaries work, as does an old
	    INFORMIX-2.10 for SCO. Further testing is necessary
	    to complete this project. There is also work under
	    way for ELF and XOUT loaders, and most of the svr4
	    syscall wrappers are written.

	    Owner: S&oslash;ren Schmidt (sos) and Sean Eric Fagan (sef)

	    Sources involved: <tt>sys/i386/ibcs2/*</tt> and misc
	    kernel changes.

	</descrip>
<!--
    <sect1><heading>Reporting problems, making suggestions, submitting code</heading>

      <p>Your suggestions, bug reports and contributions of code
	are always valued - please do not hesitate to report any
	problems you may find (preferably with a fix attached if
	you can!).

	The preferred method to submit bug reports from a machine
	with Internet mail connectivity is to use the send-pr
	command.  Bug reports will be dutifully filed by our
	faithful bug-filer program and you can be sure that we'll
	do our best to respond to all reported bugs as soon as
	possible.

	If, for some reason, you are unable to use the send-pr
	command to submit a bug report, you can try to send it
	to: <tscreen>bugs@FreeBSD.org</tscreen> Otherwise, for
	any questions or suggestions, please send mail to:
	<tscreen>questions@FreeBSD.org</tscreen>

	Additionally, being a volunteer effort, we are always
	happy to have extra hands willing to help - there are
	already far more enhancements to be done than we can ever
	manage to do by ourselves!  To contact us on technical
	matters, or with offers of help, you may send mail to:
	<tscreen>hackers@FreeBSD.org</tscreen>

	Since these mailing lists can experience significant
	amounts of traffic, if you have slow or expensive mail
	access and you are only interested in keeping up with
	significant FreeBSD events, you may find it preferable to
	subscribe to: <tscreen>announce@FreeBSD.org</tscreen>

	All but the freebsd-bugs groups can be freely joined by
	anyone wishing to do so.  Send mail to
	MajorDomo@FreeBSD.org and include the keyword `help' on a
	line by itself somewhere in the body of the message.
	This will give you more information on joining the
	various lists, accessing archives, etc.  There are a
	number of mailing lists targeted at special interest
	groups not mentioned here, so send mail to majordomo and
	ask about them!

-->
]]>
